<template>
  <div v-if="$subsReady">
    <div>
      <input type="text" v-model="description">
      <button @click="create()">Create Todo</button>
    </div>  
    <div>Done: <input type="checkbox" v-model="done"></div>
    <transition-group name="fade" tag="div">
      <div @click="toggle(todo)" v-bind:key="todo.id" v-for="todo in myTodos" class="hand" v-bind:class="{ done: todo.done }">
        {{ todo.description }}
      </div>  
    </transition-group>
  </div>
  <div v-else>
    Loading...
  </div>
</template>

<script>
import { SDP_Mixin, sdpComputed } from 'subsdata'

export default {
  name: 'Todos',
  mixins: [SDP_Mixin],
  props: {
  },
  predicates: {
    todos: ['todos', 'done']
  },
  data(){
    return {
      done: false,
      description: ""
    }
  },
  computed: {
    todos(){
      return sdpComputed(this, 'done')
    },
    myTodos(){
      return this.$store.state.sdp.subs.todos
    }
  },
  methods: {
    async toggle(todo){
      await this.$rpc('set_done', {id: todo.id, value: !todo.done})
    },
    async create(){
      await this.$rpc('create_todo', {description: this.description})
      this.description = ""
    }
  }
}
</script>

<style lang="scss">
  .done{
    text-decoration:line-through;
  }
  .hand{
    cursor: pointer;
  }

  .fade-enter-active, .fade-leave-active {
    transition: opacity .5s;
  }

  .fade-enter, .fade-leave-to {
    opacity: 0;
  }

</style>
